<?php

namespace App\Filament\Exports;

use App\Models\WireMasterPacking;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class WireMasterPackingExporter extends Exporter
{
    protected static ?string $model = WireMasterPacking::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.code')
            ->label('PLANT CODE'),
            ExportColumn::make('item.code')
            ->label('ITEM CODE'),
            ExportColumn::make('customerPo.customer_po')
            ->label('CUSTOMER PO NUMBER'),
            ExportColumn::make('wire_packing_number')
            ->label('WIRE PACKING NUMBER'),
            ExportColumn::make('process_order')
            ->label('PROCESS ORDER'),
            ExportColumn::make('batch_number')
            ->label('BATCH NUMBER'),
            ExportColumn::make('weight')
            ->label('WEIGHT'),
            ExportColumn::make('wire_packing_status')
            ->label('WIRE PACKING STATUS'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('scanned_at')
            ->label('SCANNED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('scanned_by')
            ->label('SCANNED BY'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT')
            ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your wire master packing export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
